' William Tell
' By Ted Felix

' Copyright 1982, 2003, Ted Felix, All Rights Reserved

' My first game for the IBM PC.
' Originally completed 7/16/1982, within three weeks of my first IBM PC.

' To Do
' - Use TIMER during arrow flight to maximize "frame rate".  Similar to
'   what I did in Mars Lander, determine position of arrow based on current
'   time and speed.  Then draw the arrow at the maximum rate of the machine.
'   Optimize out periods of time where the arrow doesn't move.

' History
' 2/20/2003 - Finished CPU speed independence.
' 2/18/2003 - Made CPU speed independent with TIMER.
' 2/4/2003 - Converted to QBASIC and cleaned up.
' 7/16/1982 - BASICA version completed.

DECLARE SUB Sleep2 (Seconds AS SINGLE)
DECLARE SUB StartScreen (Score!)

DEF FNRAND (X) = INT(RND * X) + 1

RANDOMIZE TIMER

' Arrow speed.  Notice that it isn't based on the points earned.
' It probably should be.
Speed = 1.3

Arrow$ = ">>---}"

KEY OFF
SCREEN 0, 0, 0
WIDTH 40

DO
  ' Display the starting screen
  StartScreen (Score)

  ' Wait for enter
  DO
    A$ = INKEY$
  LOOP UNTIL A$ = CHR$(13)

  ' Pick arrow's position
  Y = FNRAND(4) + 9
 
  ' Countdown to arrow launch
  FOR I = 5 TO 1 STEP -1
    IF I < 2 THEN
      LOCATE Y, 1, 0
      PRINT Arrow$;
    END IF
    LOCATE 1, 1, 0
    PRINT I;
    Sleep2 (.5)
  NEXT I

  ' Empty the key buffer
  DO
  LOOP UNTIL INKEY$ = ""

  ' The arrow flies
  FOR I = 2 TO 32 STEP Speed

    WaitTime = TIMER + .01

    ' Check for the midnight boundary
    IF WaitTime > 86400 THEN
      WaitTime = WaitTime - 86400

      ' Wait until the midnight crossing is over
      DO
      LOOP UNTIL TIMER < 100
    END IF

    A$ = INKEY$

    ' If the "up" key was pressed
    IF A$ = "-" THEN
      LOCATE Y, I - 1
      PRINT SPACE$(7 + INT(Speed + .5));
      Y = Y - 1
      IF Y < 2 THEN Y = 2
    END IF

    ' If the down key was pressed
    IF A$ = "/" THEN
      LOCATE Y, I - 1
      PRINT SPACE$(7 + INT(Speed + .5));
      Y = Y + 1
      IF Y > 18 THEN Y = 18
    END IF

    LOCATE Y, I - 1
    PRINT SPACE$(Speed + 1); Arrow$

    DO
    LOOP WHILE TIMER < WaitTime
  NEXT I

  LOCATE 18, 1

  ' Check the result.
  SELECT CASE Y
  CASE 9
    PRINT "Well Done!!"
    Score = Score + 30
    Speed = Speed + .1
  CASE 10
    PRINT "You killed him!!"
    Score = Score - 30
    Speed = Speed - .1
    IF Speed <= 0 THEN Speed = .1
  CASE 11
    PRINT "You got him through the heart!!"
    Score = Score - 20
    Speed = Speed - .05
    IF Speed <= 0 THEN Speed = .1503
  CASE 12
    PRINT "Right through the stomach!!"
    Score = Score - 15
    Speed = Speed - .3
  CASE 13
    PRINT "You've amputated his legs!!"
    Score = Score - 10
    Speed = Speed - .02
    IF Speed <= 0 THEN Speed = .1
  CASE ELSE
    PRINT "You missed!!"
  END SELECT

  LOCATE 20, 1
  PRINT "score:"; Score

  ' Wait for a bit so the user can see what happened
  Sleep2 (2)

  ' Empty the key buffer
  DO
  LOOP UNTIL INKEY$ = ""

LOOP

SUB Sleep2 (Seconds AS SINGLE)
  ' Similar to SLEEP, but cannot be interrupted by keyboard events
  ' Midnight crossing handling is untested.

  ' Compute time in the future when we can continue
  Delay! = TIMER + Seconds

  ' Check for midnight crossing
  IF Delay! >= 86400 THEN
    Delay! = Delay! - 86400

    ' Wait until midnight
    DO
    LOOP UNTIL TIMER < 100
  END IF

  ' Wait for that time to elapse
  DO
  LOOP UNTIL TIMER >= Delay!
END SUB

SUB StartScreen (Score)
  CLS
  COLOR 7, 0, 0
  PRINT "            William Tell"

  ' Draw victim
  LOCATE 9, 37
  COLOR 4, 0, 0
  PRINT "";
  COLOR 7, 0, 0
  LOCATE 10, 37
  PRINT CHR$(2)
  LOCATE 11, 36
  PRINT "_|_"
  LOCATE 12, 37
  PRINT "|"
  LOCATE 13, 36
  PRINT "/ \"

  LOCATE 20, 1
  PRINT "score:"; Score

  PRINT "Press enter to fire arrow, use the"
  PRINT "<-> and </> keys to control the arrow";
  LOCATE 24, 12
  PRINT "By: Ted Felix";
END SUB

